!
! Abstract operator class for the Generic Least 
! Squares Solver abstract interface library.

! 2012 Stanford University
! Musa Maharramov, maharram@stanford.edu
!
module base_oper
use base_vector
implicit none

! abstract operator type 
type, abstract :: ls_oper
contains
  procedure(oper_), deferred, pass(this) :: apply
end type ls_oper

abstract interface
 ! procedure interface for A:m-> d and A*:d->m
  subroutine oper_(this, m, d, adj)
    import :: ls_vector, ls_oper
    class(ls_oper), intent(inout) :: this
    class(ls_vector), intent(inout) :: m, d
    logical, intent(in) :: adj
  end subroutine oper_
!
end interface

end module base_oper
