module persist_defs
use io
implicit none


type, public, extends(persistent) :: pars
integer :: nx, ny, nz, nt
real :: x0, y0, z0, dt


integer, dimension(:), allocatable :: vals1d
real, dimension(:,:,:), allocatable :: vals3d

contains
  procedure :: load => lp
  procedure :: store => sp

end type pars


contains

!
subroutine lp(this,header)
class(pars), intent(inout) :: this
class(header_type), intent(inout) :: header
call header%load(this%nx,'nx')
call header%load(this%ny,'ny')
call header%load(this%nz,'nz')
call header%load(this%nt,'nt')
call header%load(this%x0,'x0')
call header%load(this%y0,'y0')
call header%load(this%z0,'z0')
call header%load(this%dt,'dt')
allocate(this%vals1d(this%ny))
allocate(this%vals3d(this%ny,this%nz,this%nt))
call header%load(this%vals1d,'vals1d')
call header%load(this%vals3d,'vals3d')
end subroutine lp

!
subroutine sp(this,header)
class(pars), intent(inout) :: this
class(header_type), intent(inout) :: header
call header%store(this%nx,'nx')
call header%store(this%ny,'ny')
call header%store(this%nz,'nz')
call header%store(this%nt,'nt')
call header%store(this%x0,'x0')
call header%store(this%y0,'y0')
call header%store(this%z0,'z0')
call header%store(this%dt,'dt')
call header%store(this%vals1d,'integer vals1d(ny)= binary1d')
call header%store(this%vals3d,'vals3d= binary3d')
end subroutine sp

end module persist_defs

